/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.world.classic.genlayers.river;

import net.minecraft.world.gen.layer.GenLayer;
import net.minecraft.world.gen.layer.IntCache;

import net.dries007.tfc.objects.biomes.BiomesTFC;
import net.dries007.tfc.world.classic.genlayers.GenLayerTFC;

public class GenLayerRiverInitTFC extends GenLayerTFC
{
    public GenLayerRiverInitTFC(long par1, GenLayer par3GenLayer)
    {
        super(par1);
        this.field_75909_a = par3GenLayer;
    }

    @Override
    public int[] func_75904_a(int xCoord, int zCoord, int xSize, int zSize)
    {
        int[] parentCache = this.field_75909_a.func_75904_a(xCoord, zCoord, xSize, zSize);
        int[] outCache = IntCache.func_76445_a(xSize * zSize);

        for (int z = 0; z < zSize; ++z)
        {
            for (int x = 0; x < xSize; ++x)
            {
                this.func_75903_a(x + xCoord, z + zCoord);
                int index = x + z * xSize;
                //int xn = index-1;
                //int xp = index+1;
                //int zn = index-zSize;
                //int zp = index+zSize;
                int id = parentCache[index];
                outCache[index] = !BiomesTFC.isOceanicBiome(id) && !BiomesTFC.isMountainBiome(id) ? 1 : 0;
            }
        }
        return outCache;
    }
}
